﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace fogado
{
    class Foglalas
    {
        public string Nev { get; set; }
        public string Ido { get; set; }
        public string Timestamp { get; set; }
        public int Etap { get; set; }
        public Foglalas(string nev, string ido, string time, int iv)
        {
            Nev = nev;
            Ido = ido;
            Timestamp = time;
            Etap = iv;
        }
    }

    class Program
    {
        private static List<Foglalas> beosztas = new List<Foglalas>();

        static void Main(string[] args)
        {
            Beolvasas();
            Console.WriteLine("2. feladat");
            Console.WriteLine("Foglalások száma: {0}", beosztas.Count);
            Console.WriteLine("3. feladat");
            Console.Write("Adjon meg egy nevet: ");
            string nev = Console.ReadLine();
            int db = Megszamlalas(nev);
            if (db == 0)
                Console.WriteLine("A megadott néven nincs időpontfoglalás.");
            else
                Console.WriteLine("{0} néven {1} időpontfoglalás van.", nev, db);
            Console.WriteLine("4. feladat");
            Console.Write("Adjon meg egy érvényes időpontot (pl. 17:10): ");
            string idopont = Console.ReadLine();
            Kigyujtes(idopont);
            Console.WriteLine("5. feladat");
            Foglalas legelso = Legelso();
            Console.WriteLine("Tanár neve: {0}", legelso.Nev);
            Console.WriteLine("Foglalt időpont: {0}", legelso.Ido);
            Console.WriteLine("Foglalás ideje: {0}", legelso.Timestamp);
            Console.WriteLine("6. feladat");
            Console.WriteLine("Barna Eszter legkorábban távozhat: {0}", Idostring(Szabadsavok()));
            Console.ReadLine();
        }

        private static int IntervallumID(int ora, int perc)
        {
            return ((ora * 60 + perc) - 16 * 60) / 10;
        }

        private static string Idostring(int intervallumID)
        {
            int ora = (16 * 60 + intervallumID * 10) / 60;
            int perc = (16 * 60 + intervallumID * 10) % 60;
            return ora.ToString("D2") + ":" + perc.ToString("D2");
        }

        private static void Beolvasas()
        {
            StreamReader sr = new StreamReader("fogado.txt");
            while (!sr.EndOfStream)
            {
                string[] adatsor = sr.ReadLine().Split(' ');
                int ora = int.Parse(adatsor[2].Split(':')[0]);
                int perc = int.Parse(adatsor[2].Split(':')[1]);
                beosztas.Add(new Foglalas(adatsor[0] + " " + adatsor[1], adatsor[2], adatsor[3], IntervallumID(ora, perc)));
            }
            sr.Close();
        }

        private static int Megszamlalas(string nev)
        {
            int db = 0;
            foreach (Foglalas f in beosztas)
            {
                if (f.Nev == nev)
                {
                    db++;
                }
            }
            return db;
        }

        private static void Kigyujtes(string idopont)
        {
            List<string> nevek = new List<string>();
            foreach (Foglalas f in beosztas)
            {
                if (f.Ido == idopont)
                {
                    nevek.Add(f.Nev);
                }
            }
            Rendez(nevek);
            Kiir(idopont, nevek);
        }

        private static void Rendez(List<string> nevek)
        {
            for (int i = 0; i < nevek.Count - 1; i++)
            {
                int mini = i;
                for (int k = i + 1; k < nevek.Count; k++)
                {
                    if (nevek[mini].CompareTo(nevek[k]) == 1)
                    {
                        mini = k;
                    }
                }
                if (mini != i)
                {
                    string temp = nevek[i];
                    nevek[i] = nevek[mini];
                    nevek[mini] = temp;
                }
            }
        }

        private static void Kiir(string idopont, List<string> nevek)
        {
            StreamWriter sw = new StreamWriter(idopont.Remove(2, 1) + ".txt");
            foreach (string s in nevek)
            {
                sw.WriteLine(s);
                Console.WriteLine(s);
            }
            sw.Close();
        }

        private static Foglalas Legelso()
        {
            Foglalas elso = beosztas[0];
            foreach (Foglalas f in beosztas)
            {
                if (elso.Etap > f.Etap)
                {
                    elso = f;
                }
            }
            return beosztas[0];
        }

        private static int Szabadsavok()
        {
            bool[] foglalt = new bool[12];
            for (int i = 0; i < 12; i++)
            {
                foglalt[i] = false;
            }
            foreach (Foglalas f in beosztas)
            {
                if (f.Nev == "Barna Eszter")
                {
                    foglalt[f.Etap] = true;
                }
            }

            for (int i = 0; i < 12; i++)
            {
                if (!foglalt[i])
                {
                    Console.WriteLine(Idostring(i));
                }
            }
            int utolso = 11;
            while (!foglalt[utolso])
                utolso--;

            return utolso + 1;
        }
    } 
}
